#include <stdio.h>
#include "/usr/local/express/include/express.h"

#include "psa.h"
#include "decl.h"

#define TEST 0

#if TEST
/*----------------------------------------------------------------------*/
main()
{

	FILE* fp;
	int *map, max_vertices;
	vertex_t *vertex;

	fp = fopen("final", "r");
	fscanf(fp,"%d",&max_vertices);

	map = MEM(int , max_vertices);
	vertex = MEM(vertex_t, max_vertices);

	if (read_graph(fp, vertex, map, max_vertices) < 0)
		exit(2);             /* Some error in reading graph */

}
#endif
/*-----------------------------------------------------------------------*/

int read_max_vertices(fp)
FILE *fp;
{
   int max_vertices;


   fscanf(fp, "%d", &max_vertices);

   return (max_vertices);

}

/*----------------------------------------------------------------------*/

int 
read_graph(fp, vertex, max_vertices)
FILE *fp;
vertex_t *vertex;
int max_vertices;
{	
	int i, info;

	for (i=0;fscanf(fp,"%d",&info) != EOF;i++) {
		vertex[i].deg = info;
		read_vrtx_info(fp, i, vertex);
	}

	if (i == max_vertices)
		return i;      /* Successful read, return max vertices */
	else 
		return -1;      /* There is some error */
}
/*-----------------------------------------------------------------------*/
void 
read_vrtx_info(fp, i, vertex)
FILE *fp;
int i;
vertex_t *vertex;
{
	int j, info;

	fscanf(fp,"%d",&info);
	fscanf(fp,"%d",&info);
	vertex[i].wt = info;

	if (vertex[i].deg > 0) {
	    if ((vertex[i].egwt = MEM(float,vertex[i].deg)) == NULL) {
   	       exit(10);     /* Out Of memory */
   	    }
		if ((vertex[i].nabor = MEM(int, vertex[i].deg)) == NULL) {
			exit(10); /* Out of memory */
		}     			
		for (j = 0; j<vertex[i].deg; j++) {
			fscanf(fp,"%d",&info);
			vertex[i].egwt[j] = info;
			fscanf(fp, "%d",&info);
			vertex[i].nabor[j] = info-1;
		}
	}
	else 
		if (vertex[i].deg == 0) {
			vertex[i].nabor = NULL;
			vertex[i].egwt = NULL;
		}
		else 
			exit(21);  /* Illegal vertex degree */
}
/*------------------------------------------------------------------------*/
	
