/* psa_glb_sync.c */
void glb_synchronize();

/* psa_init.c */
float find_init_temp(/*struct trans_table *table, vertex_t *vertex, int max_vertices*/);
float find_tot_change_objfn(/*vertex_t *vertex, int i, int send_proc*/);
float find_freez_temp(/*void*/);
int find_vmvs(/*double temp*/);
int equilibrium(/*int n_acc, int n_att*/);
int find_cut_edges();
int find_local_vertices();
void generate_solution();

/* psa_main.c */
int main(/*void*/);
int init_express(/*struct nodenv *pnode*/);
FILE *open_file(/*char *fname*/);

/* psa_objfn.c */
float eval_init_objfn(/*vertex_t *vertex, struct trans_table *table, int max_vertices*/);
float eval_del_objfn(/*vertex_t *vertex, int i, int send_proc, sink_t *sink, int cnt_entry_sink*/);
int node_compare(/*sink_t *node1, sink_t *node2*/);
int addf(/*float *p1, float *p2, int size*/);
int addi(/*int *p1, int *p2, int size*/);

/* psa_perturb.c */
int local_perturb(/*struct trans_table *table, vertex_t *vertex, listnode_t *ht, int max_vertices, double temp, sink_t *sink, int cnt_entry_sink*/);
int intcompare(/*sink_t *i, sink_t *j*/);
int accept_or_not(/*double dobj, double temp*/);
int rnd(/*int low, int high*/);


/* psa_read_graph.c */
int read_max_vertices();
int read_graph();
void read_vrtx_info();

